// IC-9700 SEND output splitter
// Reads radio Main Band (TX) Frequency and generates seperate send control lines depending on band.
// rob@m0dts.co.uk
// 23/6/2019

#include <SoftwareSerial.h>


unsigned char readbuf[32]; 
char currentband;
int n,len;
char band[3];
unsigned char rig_address = 0xA2;
unsigned char controller_address = 0x0;

SoftwareSerial ic9700_Serial(10, 11,0); // RX, TX

void setup() {
  Serial.begin(19200);    //debug
  Serial.println("IC9700 Send Splitter Started.");    //debug
  
  ic9700_Serial.begin(19200);
  ic9700_Serial.setTimeout(200);
  
  pinMode(2, OUTPUT); //2m
  pinMode(3, OUTPUT); //70cm
  pinMode(4, OUTPUT); //23cm
}





void loop() {
 
  //send command to read main vfo band                               \/   \/
  unsigned char getfreq[]={0xFE,0xFE,rig_address,controller_address,0x25,0x00,0xFD};
  int n,count=0;
  for(n=0;n<10;n++){
    if(digitalRead(11)==0){
      count++;
    }
    delay(1);
  }
  if(count==0){
    ic9700_Serial.write((char*)getfreq,7);

    //read response from radio
    len = ic9700_Serial.readBytesUntil(0xFD, readbuf, 32);
    if(len==12){
      if(readbuf[0]==0xFE & readbuf[0]==0xFE){  //check alignment
        if (readbuf[10]!=currentband){    //if GHz/100MHz have changed 
          currentband=readbuf[10];
          switch(readbuf[10]){
            case 0x01:
            band[0]=1;
            band[1]=0;
            band[2]=0;
            Serial.println("2m");
            break;
        
            case 0x04:
            band[0]=0;
            band[1]=1;
            band[2]=0;
            Serial.println("70cm");
            break;
        
            case 0x12:
            band[0]=0;
            band[1]=0;
            band[2]=1;
            Serial.println("23cm");
            break;
          }
          
          for(n=0;n<3;n++){
            digitalWrite(n+2,band[n]);
          }
        }
      }
    }
  }
} 
